evil_string.h File Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

- File List
- Globals

Functions
evil_string.h File Reference

The file that provides functions ported from Unix in string.h. More...

## Functions
char * | strndup (const char *str, size_t n)
| Duplicate a string. More...
int | ffs (int i)
| Return the position of the first (least significant) bit set in a word. More...
char * | strrstr (const char *str, const char *substr)
| Get the last substring occurence. More...
char * | strcasestr (const char *haystack, const char *needle)
| Locate a substring into a string, ignoring case. More...
char * | strsep (char **stringp, const char *delim)
| Implements the strsep function which is used to separate strings. More...

## Detailed Description

The file that provides functions ported from Unix in string.h.

## Function Documentation

char* strndup | ( | const char * | str,
|  | size_t | n
| ) |  |

Duplicate a string.

Parameters

  str | String to be duplicated
  n | size of new duplicated string

Returns
  The strndup() function returns a pointer to the duplicated string, or NULL if insufficient memory was available.

This function returns a pointer to a new string which is a duplicate of the string str, but only copies at most n bytes. If str is longer than n, only n bytes are copied, and a terminating null byte ('\0') is added.

Conformity: BSD

Supported OS: Windows XP.

int ffs | ( | int | i | ) |

Return the position of the first (least significant) bit set in a word.

Parameters

  i | Word to take the first bit.

Returns
  The position of the first bit set, or 0 if no bits are set.

This function returns the position of the first (least significant) bit set in `i`. The least significant bit is position 1 and the most significant position e.g. 32 or 64. The function returns 0 if no bits are set in `i`, or the position of the first bit set otherwise.

Conformity: BSD

Supported OS: Windows XP.

char* strrstr | ( | const char * | str,
|  | const char * | substr
| ) |  |

Get the last substring occurence.

Parameters

  str | The string to search from.
  substr | The substring to search.

Returns
  The last occurrence of the substring if found, `NULL` otherwise.

This function retrieves the last occurrence of `substring` in the string `str`. If `str` or `substr` are `NULL`, of if `substr` is not found in `str`, `NULL` is returned.

Conformity: Non applicable.

Supported OS: Windows XP.

char* strcasestr | ( | const char * | haystack,
|  | const char * | needle
| ) |  |

Locate a substring into a string, ignoring case.

Parameters

  haystack | The string to search in.
  needle | The substring to find.

Returns

This function locates the string `needle` into the string `haystack`, ignoring the case of the characters. It returns apointer to the beginning of the substring, or NULL if the substring is not found. If `haystack` or `needle` are `NULL`, this function returns `NULL`.

Conformity: Non applicable.

Supported OS: Windows XP.

char* strsep | ( | char ** | stringp,
|  | const char * | delim
| ) |  |

Implements the strsep function which is used to separate strings.

Parameters

  stringp | The pointer to the string to search in.
  delim | The delimiter that contains characters used to find the next token.

Returns
  a pointer to the next token or NULL;

The strsep() function locates, in the string referenced by *stringp, the first occurrence of any character in the string delim (or the terminating `\0' character) and replaces it with a `\0'. The location of the next character after the delimiter character (or NULL, if the end of the string was reached) is stored in *stringp. The original value of stringp is returned.

An ``empty'' field (i.e., a character in the string delim occurs as the first character of *stringp) can be detected by comparing the location referenced by the returned pointer to `\0'.

If *stringp is initially NULL, strsep() returns NULL.

This function is from LibGW32C.

Since
  1.8